version: '3.7'

services:

  server:
    image: rancher/k3s:v1.17.2-k3s1
    restart: "always"
    ports:
      - "6443:6443"
    command: server --disable-agent
    environment:
      - "K3S_CLUSTER_SECRET=6cYlQXAmzBFAnNIWwHdO4fTiM4mmpjDjEMViMG"
      - "K3S_KUBECONFIG_OUTPUT=/output/kubeconfig.yaml"
      - "K3S_KUBECONFIG_MODE=666"
    volumes:
      - "$PWD/.data/k3s:/output"
      - "k3s-server:/var/lib/rancher/k3s"
    networks:
      - "k3s-server"

  node:
    image: rancher/k3s:v1.17.2-k3s1
    restart: "always"
    privileged: true
    ports:
      - "80:80"
    tmpfs:
      - /run
      - /var/run
    depends_on:
      - server
    environment:
      - "K3S_CLUSTER_SECRET=6cYlQXAmzBFAnNIWwHdO4fTiM4mmpjDjEMViMG"
      - "K3S_URL=https://server:6443"
    networks:
      - "k3s-server"

volumes:
  k3s-server: {}

networks:
  k3s-server:
    driver: bridge
